package it.unibas.appuntamenti.controllo;

import it.unibas.appuntamenti.modello.Agenda;
import it.unibas.appuntamenti.modello.Giorno;
import it.unibas.appuntamenti.modello.Orario;
import it.unibas.appuntamenti.modello.Impegno;
import it.unibas.appuntamenti.modello.Lezione;
import it.unibas.appuntamenti.modello.Riunione;

public class ControlloSecondario {
    
    public void schermoAggiungiAppuntamento(Agenda agenda) {
        System.out.println("---------------------------------");
        System.out.println("  Inserimento Appuntamenti");
        System.out.println("---------------------------------");
        Giorno giorno = Utilita.cercaEInserisciGiorno(agenda);
        if (giorno != null) {
            Utilita.stampaAppuntamentiGiorno(giorno);
            System.out.println("Nuovo appuntamento");
            System.out.println("------------------");
            Impegno impegno;
            int tipo = schermoTipoAppuntamento();
            if (tipo == 1) {
                impegno = schermoLeggiRiunione();
            } else {
                impegno = schermoLeggiLezione();
            }
            giorno.addImpegno(impegno);
            Utilita.stampaAppuntamentiGiorno(giorno);
        }
    }
    
    private int schermoTipoAppuntamento() {
        int scelta;
        System.out.println("Scegli il tipo di appuntamento");
        System.out.println("------------------------------");
        System.out.println("   1. Riunione");
        System.out.println("   2. Lezione");
        System.out.println();
        System.out.print("   Scelta ----> ");
        scelta = it.unibas.utilita.Console.leggiIntero();
        while (scelta < 1 || scelta > 2) {
            System.out.println("ERRORE. Valore Scorretto");
            System.out.print("Ripeti -->");
            scelta = it.unibas.utilita.Console.leggiIntero();
        }
        return scelta;
    }
    
    private Riunione schermoLeggiRiunione(){
        System.out.println("Immetti i dati della riunione");
        System.out.println("-----------------------------");
        Orario orario = Utilita.schermoLeggiOrario();
        System.out.print("Descrizione  --> ");
        String descrizione = it.unibas.utilita.Console.leggiStringa();
        System.out.print("Luogo        --> ");
        String luogo = it.unibas.utilita.Console.leggiStringa();
        System.out.print("Partecipanti --> ");
        String partecipanti = it.unibas.utilita.Console.leggiStringa();
        System.out.print("Note         --> ");
        String note = it.unibas.utilita.Console.leggiStringa();
        Riunione riunione = new Riunione(descrizione, partecipanti, luogo, note, orario);
        return riunione;
    }
    
    private Lezione schermoLeggiLezione(){
        System.out.println("Immetti i dati della lezione");
        System.out.println("-----------------------------");
        Orario orario = Utilita.schermoLeggiOrario();
        System.out.print("Corso        --> ");
        String corso = it.unibas.utilita.Console.leggiStringa();
        System.out.print("Aula         --> ");
        String aula = it.unibas.utilita.Console.leggiStringa();
        System.out.print("Note         --> ");
        String note = it.unibas.utilita.Console.leggiStringa();
        Lezione lezione = new Lezione(corso, aula, note, orario);
        return lezione;
    }
    
    public void schermoEliminaAppuntamento(Agenda agenda) {
        System.out.println("---------------------------------");
        System.out.println("   Eliminazione Appuntamenti");
        System.out.println("---------------------------------");
        Giorno giorno = Utilita.cercaGiorno(agenda);
        if (giorno == null || giorno.getNumeroImpegni() == 0) {
            System.out.println("Non ci sono appuntamenti nel giorno specificato");
        } else {
            int scelta = schermoLeggiNumeroImpegno(giorno);
            giorno.removeImpegno(scelta);
            if (giorno.getNumeroImpegni() == 0) {
                agenda.removeGiorno(giorno.toShortString());
            }
            System.out.println("Eliminazione Efettuata");
            System.out.println("---------------------------------");
            Utilita.stampaAppuntamentiGiorno(giorno);
            System.out.println("---------------------------------");
        }
    }
    
    private int schermoLeggiNumeroImpegno(Giorno giorno) {
        Utilita.stampaAppuntamentiGiorno(giorno);
        System.out.print("Scelta --> ");
        int scelta = it.unibas.utilita.Console.leggiIntero();
        while (scelta < 0 || scelta >= giorno.getNumeroImpegni()) {
            System.out.println("ERRORE: scelta scorretta");
            System.out.print("Ripeti -->");
            scelta = it.unibas.utilita.Console.leggiIntero();
        }
        return scelta;
    }

}
