package it.unibas.appuntamenti.controllo;

import it.unibas.appuntamenti.modello.Agenda;
import it.unibas.appuntamenti.modello.Giorno;

public class Principale {

    public void esegui() {
        Agenda agenda = new Agenda();
        ControlloSecondario controlloSecondario = new ControlloSecondario();
        boolean continua = true;
        while (continua) {
            int scelta = schermoMenuPrincipale();
            if (scelta == 0) {
                continua = false;
            } else if (scelta ==  1) {
                agenda = schermoNuovaAgenda();
            } else if (scelta == 2) {
                agenda = schermoCaricaAgenda();
            } else if (scelta == 3) {
                schermoVisualizzaAppuntamenti(agenda);
            } else if (scelta == 4) {
                controlloSecondario.schermoAggiungiAppuntamento(agenda);
            } else if (scelta == 5) {
                controlloSecondario.schermoEliminaAppuntamento(agenda);
            } else if (scelta == 6) {
                schermoStampaAgenda(agenda);
            } else if (scelta == 7) {
                schermoSalvaAgenda(agenda);
            }
        }
    }

    private int schermoMenuPrincipale() {
        int scelta;
        System.out.println("-----------------------------------------");
        System.out.println("          Agenda di Appuntamenti         ");
        System.out.println("------------------------------------------");
        System.out.println();
        System.out.println("   1. Crea una nuova agenda");
        System.out.println("   2. Carica agenda da file");
        System.out.println("   3. Visualizza appuntamenti per giorno");
        System.out.println("   4. Aggiungi appuntamento");
        System.out.println("   5. Elimina appuntamento");
        System.out.println("   6. Visualizza tutti gli appuntamenti");
        System.out.println("   7. Salva agenda su file");
        System.out.println();
        System.out.println("   0. Esci");
        System.out.println();
        System.out.print("   Scelta ----> ");
        scelta = it.unibas.utilita.Console.leggiIntero();
        while ((scelta < 0) || (scelta > 7)) {
            System.out.print("   Errore. Ripeti ----> ");
            scelta = it.unibas.utilita.Console.leggiIntero();
        }
        return scelta;
    }

    private Agenda schermoNuovaAgenda() {
        System.out.println("---------------------------------");
        System.out.println("     Creazione Nuova Agenda");
        System.out.println("---------------------------------");
        System.out.println("Inserisci il nome dell'utente --> ");
        String utente = it.unibas.utilita.Console.leggiStringa();
        Agenda agenda = new Agenda();
        agenda.setUtente(utente);
        System.out.println("--------------------------------");
        return agenda;
    }

    private Agenda schermoCaricaAgenda() {
        System.out.println("---------------------------------");
        System.out.println("       Caricamento Agenda");
        System.out.println("---------------------------------");
        System.out.print("Inserisci il nome del file --> ");
        String nomeFile = it.unibas.utilita.Console.leggiStringa();
        Agenda agenda = null;
        try {
            agenda = Agenda.carica(nomeFile);
            System.out.println(" -- Caricamento effettuato -- ");
        } catch (java.io.IOException ioe) {
            System.out.println("ERRORE: " + ioe);
        }
        schermoStampaAgenda(agenda);
        return agenda;
    }

    private void schermoStampaAgenda(Agenda agenda) {
        System.out.println("---------------------------------");
        System.out.println("      Riassunto Agenda");
        System.out.println("---------------------------------");
        System.out.println(agenda);
        System.out.println("---------------------------------");
    }

    private void schermoSalvaAgenda(Agenda agenda){
        System.out.println("---------------------------------");
        System.out.println("       Salvataggio Agenda");
        System.out.println("---------------------------------");
        System.out.print("Inserisci il nome del file --> ");
        String nomeFile = it.unibas.utilita.Console.leggiStringa();
        try {
            agenda.salva(nomeFile);
            System.out.println(" -- Salvataggio effettuato -- ");
        } catch (java.io.IOException ioe) {
            System.out.println("ERRORE: " + ioe);
        System.out.println("--------------------------------");
        }
    }

    public void schermoVisualizzaAppuntamenti(Agenda agenda) {
        System.out.println("---------------------------------");
        System.out.println("  Visualizzazione Appuntamenti");
        System.out.println("---------------------------------");
        Giorno giorno = Utilita.cercaGiorno(agenda);
        Utilita.stampaAppuntamentiGiorno(giorno);
        System.out.println("--------------------------------");
    }

    public static void main(String[] args) {
        Principale principale = new Principale();
        principale.esegui();
    }

}
