package it.unibas.appuntamenti.controllo;

import it.unibas.appuntamenti.modello.*;

public class Utilita {
    
    static Giorno cercaGiorno(Agenda agenda) {
        System.out.println("Immetti la data");
        System.out.println("----------------");
        int gg = leggiGg();
        int mese = leggiMese();
        int anno = leggiAnno();
        String data = Giorno.costruisciStringaData(gg, mese, anno); 
        Giorno giorno = agenda.getGiorno(data);
        return giorno;
    }
    
    static Giorno cercaEInserisciGiorno(Agenda agenda) {
        System.out.println("Immetti la data");
        System.out.println("----------------");
        int gg = leggiGg();
        int mese = leggiMese();
        int anno = leggiAnno();
        String data = Giorno.costruisciStringaData(gg, mese, anno); 
        Giorno giorno = agenda.getGiorno(data);
        if (giorno == null) {
            try {
                giorno = new Giorno(gg, mese, anno);
                agenda.addGiorno(giorno.toShortString(), giorno);
            } catch (Exception e) {
                System.out.println("ERRORE: " + e);
                return null;
            }
        }
        return giorno;
    }

    static void stampaAppuntamentiGiorno(Giorno giorno) {
        System.out.println("Appuntamenti del giorno");
        System.out.println("-----------------------");
        if (giorno == null || giorno.getNumeroImpegni() == 0) {
            System.out.println("  Non ci sono appuntamenti nel giorno specificato");
        } else {
            System.out.println(giorno);
        }        
    }
    
    private static int leggiGg() {
        System.out.print("Giorno   (1-31) --> ");
        int gg = it.unibas.utilita.Console.leggiIntero();
        while (gg < 1 || gg > 31) {
            System.out.println("ERRORE: valore scorretto");
            System.out.print("Ripeti --> ");
            gg = it.unibas.utilita.Console.leggiIntero();
        }
        return gg;
    }

    private static int leggiMese() {
        System.out.print("Mese     (1-12) --> ");
        int mese = it.unibas.utilita.Console.leggiIntero();
        while (mese < 1 || mese > 12) {
            System.out.println("ERRORE: valore scorretto");
            System.out.print("Ripeti --> ");
            mese = it.unibas.utilita.Console.leggiIntero();
        }
        return mese;
    }

    private static int leggiAnno() {
        System.out.print("Anno (es: 2004) --> ");
        int anno = it.unibas.utilita.Console.leggiIntero();
        while (anno < 1990) {
            System.out.println("ERRORE: valore scorretto");
            System.out.print("Ripeti --> ");
            anno = it.unibas.utilita.Console.leggiIntero();
        }
        return anno;
    }
    
    static Orario schermoLeggiOrario() {
        System.out.println("Immetti l'orario");
        System.out.println("----------------");
        int ora = leggiOra();
        int minuti = leggiMinuti();
        Orario orario = new Orario(ora, minuti);
        return orario;
    }
    
    private static int leggiOra() {
        System.out.print("Ora      (0-23) --> ");
        int ora = it.unibas.utilita.Console.leggiIntero();
        while (ora < 0 || ora > 23) {
            System.out.println("ERRORE: valore scorretto");
            System.out.print("Ripeti --> ");
            ora = it.unibas.utilita.Console.leggiIntero();
        }
        return ora;
    }

    private static int leggiMinuti() {
        System.out.print("Minuti   (0-59) --> ");
        int minuti = it.unibas.utilita.Console.leggiIntero();
        while (minuti < 0 || minuti > 59) {
            System.out.println("ERRORE: valore scorretto");
            System.out.print("Ripeti --> ");
            minuti = it.unibas.utilita.Console.leggiIntero();
        }
        return minuti;
    }
    
}
