package it.unibas.appuntamenti.modello;

public abstract class ImpegnoAstratto implements Impegno {
    
    protected String luogo;
    protected String note;
    protected Orario orario;
    protected Giorno giorno;
    
    protected ImpegnoAstratto() {}
    
    protected ImpegnoAstratto(String luogo, String note, Orario orario) {
        this.luogo = luogo;
        this.note = note;
        this.orario = orario;
    }
    
    public java.lang.String getLuogo() {
        return luogo;
    }
    
    public void setLuogo(java.lang.String luogo) {
        this.luogo = luogo;
    }

    public java.lang.String getNote() {
        return note;
    }    
    
    public void setNote(java.lang.String note) {
        this.note = note;
    }
  
    public Orario getOrario() {
        return this.orario;
    }
    
    public void setOrario(Orario orario) {
        this.orario = orario;
    }

    public Giorno getGiorno() {
        return this.giorno;
    }    
    
    public void setGiorno(Giorno giorno) {
        giorno.addImpegno(this);
        this.giorno = giorno;
    }

    public int compareTo(Object o){
        return this.orario.compareTo(((Impegno)o).getOrario());
    }

    public abstract String toString();
            
    public abstract String saveString();
    
}
