package it.unibas.appuntamenti.modello;

public class Orario implements Comparable {
    
    private java.util.GregorianCalendar calendar;
    
    public Orario(int ora, int minuti) {
        if (ora < 0 || ora > 23) {
            throw new IllegalArgumentException("Valore scorretto dell'ora: " + ora);
        }
        if (minuti < 0 || minuti > 59) {
            throw new IllegalArgumentException("Valore scorretto dei minuti: " + minuti);
        }
        this.calendar = new java.util.GregorianCalendar(1970, java.util.Calendar.JANUARY, 1, ora, minuti);
    }
    
    public int getOra() {
        return this.calendar.get(java.util.Calendar.HOUR_OF_DAY);
    }

    public int getMinuti() {
        return this.calendar.get(java.util.Calendar.MINUTE);
    }
    
    public String toString() {
        String padOra = "";
        String padMinuti = "";
        if (this.getOra() < 10) {
            padOra = " ";
        }
        if (this.getMinuti() < 10) {
            padMinuti = "0";
        }
        return padOra + getOra() + ":" + padMinuti + getMinuti();
    } 
    
    public boolean equals(Orario orario) {
        return this.toString().equals(orario.toString());
    }    
    
    public int compareTo(Object orario) {
        java.util.Date questaData = this.calendar.getTime();
        java.util.Date altraData = ((Orario)orario).calendar.getTime();
        return questaData.compareTo(altraData);
    }      
}
