package it.unibas.appuntamenti.test;

import junit.framework.*;
import it.unibas.appuntamenti.modello.*;

public class TestGiorno extends TestCase {
    
    private Giorno giorno255;
    private Riunione riunione1330;
    private Lezione lezione1330; 
    private Lezione lezione1500; 
    private Orario orario1330;
    private Orario orario1500;
    
    public void setUp() {
        giorno255 = new Giorno(25, 5, 2004);
        orario1330 = new Orario(13, 30);
        riunione1330 = new Riunione("impegno di prova", "tizio e caio", "Universit", "*", orario1330);
        orario1500 = new Orario(15, 00);
        lezione1500 = new Lezione("lezione di prova", "Aula 1", "*", orario1500);
        lezione1330 = new Lezione("lezione di prova 2", "Aula Magna", "*", orario1330);
    }
    
    public void testGiorno1() {
        Assert.assertTrue("25", giorno255.getNumGiorno() == 25);
        Assert.assertTrue("5", giorno255.getMese() == java.util.Calendar.MAY);
        Assert.assertTrue("2004", giorno255.getAnno() == 2004);
        Assert.assertTrue("martedi", giorno255.getGiornoSettimana() == java.util.Calendar.TUESDAY);
        //Assert.assertTrue("stringa ", giorno255.toString().equals("marted 25 maggio 2004"));
        Assert.assertTrue("stringa corta ", giorno255.toShortString().equals("25/05/04"));
    }
   
    public void testGiorno2() {
        giorno255.addImpegno(lezione1500);
        giorno255.addImpegno(riunione1330);
        String stringaImpegni = giorno255.stringaImpegni();
        //System.out.println(stringaImpegni);
        Assert.assertTrue("13:30", stringaImpegni.indexOf("13:30") != -1);
        Assert.assertTrue("15:00", stringaImpegni.indexOf("15:00") != -1);
        Assert.assertTrue("ordine", stringaImpegni.indexOf("15:00") >
                                    stringaImpegni.indexOf("13:30"));
    }

    public void testGiorno3() {
        Assert.assertTrue("stringa data1", Giorno.costruisciStringaData(25, 5, 2004).equals("25/05/04"));
        Assert.assertTrue("stringa data2", Giorno.costruisciStringaData(5, 12, 1999).equals("05/12/99"));
    }
}
